<?php
/*
Plugin Name: Bubok to WordPress plugin
Description: Plugin to see the books who have the user in bubok in the WordPress menu
Version: 0.1
Author: Bubok
Author URI: http://www.bubok.com/
*/

define('BUBOKTOWORDPRESSPATH', ABSPATH.'wp-content/plugins/buboktowordpress');
define('BUBOKTOWORDPRESSURL', get_option('siteurl').'/wp-content/plugins/buboktowordpress');
define('BUBOKTOWORDPRESSJSURL', BUBOKTOWORDPRESSURL.'/js');;
define('BUBOKTOWORDPRESSTMPURL', '/tmp');

require_once(BUBOKTOWORDPRESSPATH . '/cacheLite/Lite.php');

define ("URL_BUBOK"	, "http://www.bubok.es/servicios/getAutor/");
define ("URL_BUBOK_LIBRO"	, "http://www.bubok.com/libros/");

$options = array('cacheDir' => BUBOKTOWORDPRESSTMPURL.'/', 'lifeTime' => 3600 );
$Cache_Lite = new Cache_Lite($options);

function btwGetXML ($url)
{
	$ch = curl_init();    // initialize curl handle
	
	curl_setopt ($ch, CURLOPT_URL,$url); // set url to post to
	curl_setopt ($ch, CURLOPT_USERAGENT, "");
	curl_setopt ($ch, CURLOPT_HEADER, 0);
	curl_setopt ($ch, CURLOPT_FAILONERROR, 1);
	curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);// allow redirects
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER,1); // return into a variable
	curl_setopt ($ch, CURLOPT_TIMEOUT, 5); // times out after 4s
	curl_setopt ($ch, CURLOPT_BINARYTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 1);
	
	$result = curl_exec($ch); // run the whole process
	
	curl_close($ch);
	
	
	if($result != 'Autor desconocido')
	{
		$xml = new SimpleXMLElement($result);

		$datos = array();
		$datos["foto"] = $xml->foto;
		$datos["nombre"] = $xml->nombre;
		$datos["url_perfil"] = $xml->url;
		
		if(count($xml->libro) > 0)
		{
			
			for($i=0; $i<count($xml->libro); $i++)
			{
				$titol = split( '[/]', $xml->libro[$i]->url );
				//$libros[$i]["titulo"] =  ucfirst (str_replace("-"," ",$titol[(count($titol)-1)]));
				$libros[$i]["titulo"] =  $xml->libro[$i]->titulo;
				$libros[$i]["link"] =  $xml->libro[$i]->url;
				$libros[$i]["portada"] = $xml->libro[$i]->portada;
				$libros[$i]["sinopsis"] = substr($xml->libro[$i]->sinopsis, 0, 500);
				if (strlen ($xml->libro[$i]->sinopsis) > 500) $libros[$i]["sinopsis"] .= "..."; 
				
			}
			$datos["libros"] = $libros;
			return $datos;
		}
		else
		{
			echo "<br/>No se han encontrado libros para este usuario.";
			
		}
	
	}
	else
	{
		echo "<br/>Usuario inexistente.";
	}
	
	return false;
}

function btwMostrar($args)
{	
	extract ($args);
	
	global $Cache_Lite;
	
	$user = "editorialgrupobuho"; $portada = true; $chSinopsi = true; /*$precio = true;*/ $nporpagina = 5; $timeout = 15;

	$options = get_option('buboktowordpress');
	if($options['nombreusuario']!="") $user = $options['nombreusuario'];
	if($options['portada']=="on") $portada = true;
	if($options['sinopsi']=="on") $chSinopsi = true;
	/*if($options['precio']!="") $precio = $options['precio'];*/
	if($options['nporpagina']!="") $nporpagina = $options['nporpagina'];
	if($options['timeout']!="") $timeout = $options['timeout'];
	
	$timeout = $timeout*1000;
	
	define ("ICONS_SRC"	, "wp-content/plugins/buboktowordpress/icons/");
	
	if ($text = $Cache_Lite->get("$id"))
	{
		echo $text;
	}
	else
	{
		$datos = btwGetXML(URL_BUBOK.$user);
		$libros = $datos["libros"];
		$nElements = count($libros);
		
		/* la variable $text conté tot el text de la pàgina */
		$text = $before_widget;
		
		$text .= "<script>contador = 0;\n pausa = 0;\n";
		$text .= "</script>\n";
	
		$text .= $before_title.$after_title;
		$h = 0;
		$i = 0;
		while($i < $nElements)
		{
			$text .= "<div style='display:none' id='llibre".$h."'><table>";
			for($j=0; $j<$nporpagina; $j++)
			{
				if($i < $nElements)
				{
					$sinopsi = $libros[$i]['sinopsis'];
					$sinopsi = wordwrap($sinopsi, 140, "$\\$");
					$sinopsi = strtok($sinopsi, "$\\$");
					$sinopsi .= "...";
					
					$text .= "<tr><td colspan='2'>";
					$text .= '<strong><a target="_blank" href="'.$libros[$i]["link"].'" title="'.$libros[$i]["titulo"].'">'.$libros[$i]["titulo"].'</a></strong></td></tr>';
					$text .= '<tr>';
					if($portada)
					{
						$text .= '<td><a target="_blank" href="'.$libros[$i]["link"].'">';
						$text .= '<img alt="'.$libros[$i]["titulo"].'" title="'.$libros[$i]["titulo"].'" src="'.$libros[$i]["portada"].'"></a></td>';
					}
					else
						$text .= "<td></td>";
					if($chSinopsi)
						$text .= "<td>".$sinopsi."</td>";
					else
						$text .= "<td></td>";
					$text .= "</tr>";
				}
				$i++;
			} 
			$text .= "</table></div>";
			$h++;
		}
		$text .= "<div><table><tr><td onclick='enrera()'><img src='".ICONS_SRC."previous.png' alt='anterior'></td>";
		$text .= "<td onclick='pausa=(!pausa)'><img src='".ICONS_SRC."pause.png' alt='pausa'></td>";
		$text .= "<td onclick='endavant()'><img src='".ICONS_SRC."next.png' alt='siguiente'></td></tr></table></div>";
		
		$text .= "<script>timeout = ".$timeout."; elements =".$h.";\n canviarLlibre();\n</script>";
		
		$text .= $after_widget;
		
		echo $text;
		
		//$Cache_Lite->save($text, "$id");
	}
}

function btwMostrar_options()
{	
	
	global $Cache_Lite;
	
	$options = $newoptions = get_option('buboktowordpress');
	
	if ( $_POST['btwSubmit'] ) {
			// Clean up control form submission options
			$newoptions['nombreusuario'] = strip_tags(stripslashes($_POST['nombreusuario']));
			$newoptions['portada'] = strip_tags(stripslashes($_POST['portada']));
			$newoptions['sinopsi'] = strip_tags(stripslashes($_POST['sinopsi']));
			/*$newoptions['precio'] = $_POST['precio'];*/
			$newoptions['nporpagina'] = strip_tags(stripslashes($_POST['nporpagina']));
			$newoptions['timeout'] = strip_tags(stripslashes($_POST['timeout']));
			if($Cache_Lite->lastModified()!=null & $Cache_Lite->lastModified()!="")
				$Cache_Lite->clean();
	}
	
	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('buboktowordpress', $options);
	}
	
	$nombreusuario = htmlspecialchars($options['nombreusuario'], ENT_QUOTES);
	$portada = $options['portada'];
	$sinopsi = $options['sinopsi'];
	if($sinopsi) $sinopsi = "checked"; else $sinopsi = "";
	if($portada) $portada = "checked"; else $portada = "";
	/*$precio = $options['precio'];*/
	$nporpagina = $options['nporpagina'];
	$timeout = $options['timeout'];
	
	require("../wp-content/plugins/buboktowordpress/lang/buboktowordpress_es_ES.php");
	
    echo "<p>".$_nombreusuariobubok."</p><p><input type='text' name='nombreusuario' id='nombreusuario' value='".$nombreusuario."'/>.bubok.com</p>";
    echo "<p>".$_quedeseasvisualizar."?<br/><input type='checkbox' id='portada' name='portada' ".$portada."> ".$_portada."</checkbox><br/>" .
    		"<input type='checkbox' id='sinopsi' name='sinopsi' ".$sinopsi."> ".$_sinopsi."</checkbox><br/>" .
    		/*"<input type='checkbox' id='precio' name='precio' checked='".$precio."'> ".$_precio."</checkbox><br/>" .*/
    		"".$_librosporpagina.": <input size='2' type='text' id='nporpagina' name='nporpagina' value='".$nporpagina."'/><br/>" .
    		"".$_velocidadreproduccion.": <input size='2' type='text' id='timeout' name='timeout' value='".$timeout."'/>".$_segundos."<br/>" .
    		"<input type='hidden' name='btwSubmit' id='btwSubmit' value='1' /></p>";
	if($Cache_Lite->lastModified()!=null & $Cache_Lite->lastModified()!="")
		$Cache_Lite->clean();
}
	
function btwInit()
{
	global $wp_version;
	if($wp_version > "2.3")
	{
		wp_enqueue_script('buboktowordpress', BUBOKTOWORDPRESSJSURL.'/buboktowordpress.js');
		load_plugin_textdomain('buboktowordpress','wp-content/plugins/buboktowordpress/lang');
	    register_widget_control("Bubok to Wordpress", "btwMostrar_options");
	    register_sidebar_widget("Bubok to Wordpress", "btwMostrar");   
	}  
}

add_action("widgets_init", "btwInit");

?>
